Index: code/trunk/doc/api/doxy.config.in
===================================================================
--- code/trunk/doc/api/doxy.config.in	(revision 2874)
+++ code/trunk/doc/api/doxy.config.in	(revision 2876)
@@ -498,6 +498,5 @@
 # subdirectory from a directory tree whose root is specified with the INPUT tag.
 
-EXCLUDE                = src/bullet/ \
-                         .svn/
+EXCLUDE                = @CMAKE_SOURCE_DIR@/src/bullet/
 
 # The EXCLUDE_SYMLINKS tag can be used select whether or not files or 
@@ -513,5 +512,5 @@
 # for example use the pattern */test/*
 
-EXCLUDE_PATTERNS       = 
+EXCLUDE_PATTERNS       = */.svn/*
 
 # The EXAMPLE_PATH tag can be used to specify one or more files or 
Index: code/trunk/src/bullet/BulletCollision/CollisionDispatch/btCollisionWorld.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionDispatch/btCollisionWorld.h	(revision 2874)
+++ code/trunk/src/bullet/BulletCollision/CollisionDispatch/btCollisionWorld.h	(revision 2876)
@@ -5,6 +5,6 @@
 This software is provided 'as-is', without any express or implied warranty.
 In no event will the authors be held liable for any damages arising from the use of this software.
-Permission is granted to anyone to use this software for any purpose, 
-including commercial applications, and to alter it and redistribute it freely, 
+Permission is granted to anyone to use this software for any purpose,
+including commercial applications, and to alter it and redistribute it freely,
 subject to the following restrictions:
 
@@ -14,5 +14,5 @@
 */
 
-/*
+
 /**
  * @mainpage Bullet Documentation
@@ -33,15 +33,15 @@
  * Bullet comes with autogenerated Project Files for Microsoft Visual Studio 6, 7, 7.1 and 8.
  * The main Workspace/Solution is located in Bullet/msvc/8/wksbullet.sln (replace 8 with your version).
- * 
+ *
  * Under other platforms, like Linux or Mac OS-X, Bullet can be build using either using make, cmake, http://www.cmake.org , or jam, http://www.perforce.com/jam/jam.html . cmake can autogenerate Xcode, KDevelop, MSVC and other build systems. just run cmake . in the root of Bullet.
  * So if you are not using MSVC or cmake, you can run ./autogen.sh ./configure to create both Makefile and Jamfile and then run make or jam.
  * Jam is a build system that can build the library, demos and also autogenerate the MSVC Project Files.
  * If you don't have jam installed, you can make jam from the included jam-2.5 sources, or download jam from ftp://ftp.perforce.com/jam
- * 
+ *
  * @subsection step3 Step 3: Testing demos
  * Try to run and experiment with BasicDemo executable as a starting point.
  * Bullet can be used in several ways, as Full Rigid Body simulation, as Collision Detector Library or Low Level / Snippets like the GJK Closest Point calculation.
  * The Dependencies can be seen in this documentation under Directories
- * 
+ *
  * @subsection step4 Step 4: Integrating in your application, full Rigid Body and Soft Body simulation
  * Check out BasicDemo how to create a btDynamicsWorld, btRigidBody and btCollisionShape, Stepping the simulation and synchronizing your graphics object transform.
@@ -57,8 +57,8 @@
  * Special thanks to all visitors of the Bullet Physics forum, and in particular above contributors, John McCutchan, Nathanael Presson, Dave Eberle, Dirk Gregorius, Erin Catto, Dave Eberle, Adam Moravanszky,
  * Pierre Terdiman, Kenny Erleben, Russell Smith, Oliver Strunk, Jan Paul van Waveren, Marten Svanfeldt.
- * 
+ *
  */
- 
- 
+
+
 
 #ifndef COLLISION_WORLD_H
@@ -80,9 +80,9 @@
 {
 
-	
+
 protected:
 
 	btAlignedObjectArray<btCollisionObject*>	m_collisionObjects;
-	
+
 	btDispatcher*	m_dispatcher1;
 
@@ -95,5 +95,5 @@
 	btIDebugDraw*	m_debugDrawer;
 
-	
+
 public:
 
@@ -136,5 +136,5 @@
 	virtual void	updateAabbs();
 
-	
+
 	virtual void	setDebugDrawer(btIDebugDraw*	debugDrawer)
 	{
@@ -154,5 +154,5 @@
 		int	m_shapePart;
 		int	m_triangleIndex;
-		
+
 		//const btCollisionShape*	m_shapeTemp;
 		//const btTransform*	m_shapeLocalTransform;
@@ -161,5 +161,5 @@
 	struct	LocalRayResult
 	{
-		LocalRayResult(btCollisionObject*	collisionObject, 
+		LocalRayResult(btCollisionObject*	collisionObject,
 			LocalShapeInfo*	localShapeInfo,
 			const btVector3&		hitNormalLocal,
@@ -227,10 +227,10 @@
 		btVector3	m_hitNormalWorld;
 		btVector3	m_hitPointWorld;
-			
+
 		virtual	btScalar	addSingleResult(LocalRayResult& rayResult,bool normalInWorldSpace)
 		{
 			//caller already does the filter on the m_closestHitFraction
 			btAssert(rayResult.m_hitFraction <= m_closestHitFraction);
-			
+
 			m_closestHitFraction = rayResult.m_hitFraction;
 			m_collisionObject = rayResult.m_collisionObject;
@@ -251,5 +251,5 @@
 	struct LocalConvexResult
 	{
-		LocalConvexResult(btCollisionObject*	hitCollisionObject, 
+		LocalConvexResult(btCollisionObject*	hitCollisionObject,
 			LocalShapeInfo*	localShapeInfo,
 			const btVector3&		hitNormalLocal,
@@ -278,5 +278,5 @@
 		short int	m_collisionFilterGroup;
 		short int	m_collisionFilterMask;
-		
+
 		ConvexResultCallback()
 			:m_closestHitFraction(btScalar(1.)),
@@ -289,5 +289,5 @@
 		{
 		}
-		
+
 		bool	hasHit() const
 		{
@@ -295,5 +295,5 @@
 		}
 
-		
+
 
 		virtual bool needsCollision(btBroadphaseProxy* proxy0) const
@@ -322,10 +322,10 @@
 		btVector3	m_hitPointWorld;
 		btCollisionObject*	m_hitCollisionObject;
-		
+
 		virtual	btScalar	addSingleResult(LocalConvexResult& convexResult,bool normalInWorldSpace)
 		{
 //caller already does the filter on the m_closestHitFraction
 			btAssert(convexResult.m_hitFraction <= m_closestHitFraction);
-						
+
 			m_closestHitFraction = convexResult.m_hitFraction;
 			m_hitCollisionObject = convexResult.m_hitCollisionObject;
@@ -350,5 +350,5 @@
 	/// rayTest performs a raycast on all objects in the btCollisionWorld, and calls the resultCallback
 	/// This allows for several queries: first hit, all hits, any hit, dependent on the value returned by the callback.
-	void	rayTest(const btVector3& rayFromWorld, const btVector3& rayToWorld, RayResultCallback& resultCallback) const; 
+	void	rayTest(const btVector3& rayFromWorld, const btVector3& rayToWorld, RayResultCallback& resultCallback) const;
 
 	// convexTest performs a swept convex cast on all objects in the btCollisionWorld, and calls the resultCallback